(module app-bad mzscheme
  (require "redex.scm"
           (lib "list.ss"))
  
  (define lang
    (language
     (p (store (x v) ...) e)
     (e (set! x e)
        (e e ...)
        (begin e e ...)
        x
        v)
     (v (lambda (x ...) e)
        number
        -
        unspecified)
     (x (variable-except - lambda set! begin unspecified))
     
     (inert e (mark v))
     (P (store ((x v) ...) E))
     (E (e ... E e ...)
        (set! variable E)
        (begin E e e ...)
        hole)))
  
  (define reductions
    (reduction-relation 
     lang
     
     ; application
     (--> (name prog
                (store ((x_s v_s) ...) 
                  (side-condition
                   (in-hole E_1 ((lambda (x_1 ...) e_body) v_1 ...))
                   (= (length (term (x_1 ...)))
                      (length (term (v_1 ...)))))))
          ,(term-let ([(xp_1 ...) (variables-not-in (term prog) (term (x_1 ...)))])
             (term (store ((x_s v_s) ... (xp_1 v_1) ...)
                     (in-hole E_1 ,(substitute-all (term (x_1 ...)) 
                                                   (term (xp_1 ...))
                                                   (term e_body)))))))

     ; negation
     (--> (in-hole P_1 (- number_1))
          (in-hole P_1 ,(- (term number_1))))
     
     ; deref
     (--> (store
              ((x_1 v_1) ... (x_i v_i) (x_2 v_2) ...)
            (in-hole E_1 x_i))
          (store
              ((x_1 v_1) ... (x_i v_i) (x_2 v_2) ...)
            (in-hole E_1 v_i)))

     ; set!
     (--> (store ((x_1 v_1) 
                  ...
                  (x_i v_i)
                  (x_2 v_2) ...)
            (in-hole E_1 (set! x_i v_ip)))
          (store ((x_1 v_1) 
                  ...
                  (x_i v_ip)
                  (x_2 v_2) ...)
            (in-hole E_1 unspecified)))
     
     ; begin
     (--> (in-hole P_1 (begin e_1))
          (in-hole P_1 e_1))
     (--> (in-hole P_1 (begin v_1 e_2 e_3 ...))
          (in-hole P_1 (begin e_2 e_3 ...)))))
     
  (define (substitute-all xs vs body)
    (foldl substitute body xs vs))
  
  (define substitute
    (plt-subst
     ['- (constant)]
     [(? symbol?) (variable)]
     [(? number?) (constant)]
     [`(lambda (,x ...) ,b)
      (all-vars x)
      (build (lambda (vars body) `(lambda ,vars ,body)))
      (subterm x b)]
     [`(set! ,x ,e)
      (all-vars '())
      (build (lambda (vars name body) `(set! ,name ,body)))
      (subterm '() x)
      (subterm '() e)]
     [`(begin ,e ,e2 ...)
      (all-vars '())
      (build (lambda (vars e1 e2) `(begin ,e1 ,@e2)))
      (subterm '() e)
      (subterms '() e2)]
     [`(,f ,x ...)
      (all-vars '())
      (build (lambda (vars f x) `(,f ,@x)))
      (subterm '() f)
      (subterms '() x)]))
  
  (provide lang reductions))
