(module mv-tests mzscheme
  (require "test.scm"
           (lib "match.ss"))
  
  (define (to-mz exp)
    (match exp
      [`(error "context received wrong # of values")
        #rx"context expected [0-9]+ values?, received [0-9]+ values?"]
      [else 
       (cons 'let (cdr exp))]))
    
  (define (cmp-test-results x y)
    (cond
      [(eq? 'error (car x))
       (equal? x y)]
      [else
       ;; just compare the bodies of the stores
       (equal? (list-ref x 2)
               (list-ref y 2))]))
  
  (define mv-ts
    (test-suite
     "mv.scm"
     to-mz
     cmp-test-results
     (test ""
           '(store () ((lambda (x) x) (values (lambda (y) y))))
           '(store () (values (lambda (y) y))))
     (test ""
           '(store () (call-with-values (lambda () (lambda (y) y)) (lambda (x) x)))
           '(store () (values (lambda (y) y))))
     (test ""
           '(store () (call-with-values 
             (lambda ()
               (call-with-values
                (lambda () ((lambda (z) z) (lambda (q) q)))
                (lambda (y) y))) 
             (lambda (x) x)))
           '(store () (values (lambda (q) q))))
     (test ""
           '(store () (call-with-values 
             (lambda ()
               (call-with-values (lambda () (values (lambda (p) p)))
                                 (((lambda (z) z) (lambda (a) (a a))) (lambda (m) m))))
             (call-with-values (lambda () (values (lambda (q) q))) (lambda (x) (lambda (y) x)))))
           '(store () (values (lambda (q) q))))
     

     (test ""
           '(store () ((lambda (x) x) call-with-values))
           '(store () (values call-with-values)))
     (test ""
           '(store () (values))
           '(store () (values)))
     (test ""
           '(store () (values (lambda (x) x)))
           '(store () (values (lambda (x) x))))
     (test ""
           '(store () (values (lambda (x) x) (lambda (q) q)))
           '(store () (values (lambda (x) x) (lambda (q) q))))    
     
     (test ""
           '(store () (call-with-values (values values) (lambda () (lambda (x) x))))
           '(store () (values (lambda (x) x))))
     (test ""
           '(store () ((lambda (x) x) (values (lambda (y) y))))
           '(store () (values (lambda (y) y))))
     (test ""
           '(store () (call-with-values (lambda () (lambda (y) y)) (lambda (x) x)))
           '(store () (values (lambda (y) y))))
     
     (test ""
           '(store () (call-with-values 
             (lambda ()
               (call-with-values
                (lambda ()
                  ((lambda (z) z) (lambda (q) q)))
                (lambda (y) y)))
             (lambda (x) x)))
           '(store () (values (lambda (q) q))))
     
     (test ""
           '(store () (call-with-values 
             (lambda ()
               (call-with-values (lambda ()
                                   (values (lambda (p) p)))
                                 (((lambda (x) x) (lambda (x) (x x))) (lambda (m) m))))
             (call-with-values (lambda () (values (lambda (q) q))) 
                               (lambda (x) (lambda (y) x)))))
           '(store () (values (lambda (q) q))))
     
     (test ""
           '(store () (call-with-values (lambda () (values values values)) call-with-values))
           '(store () (values)))
     
     (test ""
           '(store () ((lambda (x y) x) (values (lambda (z) z) (lambda (q) q))))
           '(error "context received wrong # of values"))
     
     (test ""
           '(store () (begin (if #t 1 2) 3))
           '(store () (values 3)))
     
     (test ""
           '(store () (begin (values 1 2) 3))
           '(store () (values 3)))
     
     (test ""
           '(store () (if (begin 1 2) 1 2))
           '(store () (values 1)))
     
     (test ""
           '(store () ((lambda (x) (begin (set! x (begin 1 2)) x)) 1))
           '(store ((x 2)) (values 2)))
     ))

  (provide mv-ts))

